> For the complete documentation index, see [llms.txt](https://docs.amesa.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.amesa.com/reference/cli-reference/perceptor-management.md).

# Perceptor Management

Create New Perceptor

```bash
composabl perceptor new \
  --name derivative-calc \
  --description "Calculates derivative of sensor values" \
  --location ./perceptors/
```

#### Generated Perceptor Structure

```python
# perceptor.py
import time
from composabl_core import PerceptorImpl

class DemoPerceptor(PerceptorImpl):
    def __init__(self, *args, **kwargs):
        self.previous_value = None
        self.previous_time = None
    
    async def compute(self, obs_spec, obs):
        current_value = obs["counter"]
        current_time = time.time()
        value_derived = 0
        
        if self.previous_value is not None and self.previous_time is not None:
            time_delta = current_time - self.previous_time
            if time_delta > 0:
                value_derived = (current_value - self.previous_value) / time_delta
        
        self.previous_value = current_value
        self.previous_time = current_time
        
        return {"counter_derived": value_derived}
    
    def filtered_sensor_space(self, obs):
        return ["counter"]
```

#### Perceptor Commands

```bash
# Publish perceptor
composabl perceptor publish ./perceptors/derivative-calc/

# List perceptors
composabl perceptor list

# Delete perceptor
composabl perceptor delete
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.amesa.com/reference/cli-reference/perceptor-management.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
